<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.srs.comprehensive.mapper.StsBonusRulesMapper">
    
    <resultMap type="SrsBonusRules" id="SrsBonusRulesResult">
        <result property="id"    column="id"    />
        <result property="categoryName"    column="category_name"    />
        <result property="weight"    column="weight"    />
        <result property="status"    column="status"    />
        <result property="delFlag"    column="del_flag"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
    </resultMap>

    <sql id="selectStsBonusRulesVo">
        select id, category_name, weight, status, del_flag, create_by, create_time, update_by, update_time from srs_bonus_rules
    </sql>

    <select id="selectStsBonusRulesList" parameterType="SrsBonusRules" resultMap="SrsBonusRulesResult">
        <include refid="selectStsBonusRulesVo"/>
        <where>  
            <if test="categoryName != null  and categoryName != ''"> and category_name like concat('%', #{categoryName}, '%')</if>
            <if test="weight != null "> and weight = #{weight}</if>
            <if test="status != null  and status != ''"> and status = #{status}</if>
        </where>
    </select>
    
    <select id="selectStsBonusRulesById" parameterType="Long" resultMap="SrsBonusRulesResult">
        <include refid="selectStsBonusRulesVo"/>
        where id = #{id}
    </select>
        
    <insert id="insertStsBonusRules" parameterType="SrsBonusRules" useGeneratedKeys="true" keyProperty="id">
        insert into srs_bonus_rules
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="categoryName != null">category_name,</if>
            <if test="weight != null">weight,</if>
            <if test="status != null">status,</if>
            <if test="delFlag != null">del_flag,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="categoryName != null">#{categoryName},</if>
            <if test="weight != null">#{weight},</if>
            <if test="status != null">#{status},</if>
            <if test="delFlag != null">#{delFlag},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
         </trim>
    </insert>

    <update id="updateStsBonusRules" parameterType="SrsBonusRules">
        update srs_bonus_rules
        <trim prefix="SET" suffixOverrides=",">
            <if test="categoryName != null">category_name = #{categoryName},</if>
            <if test="weight != null">weight = #{weight},</if>
            <if test="status != null">status = #{status},</if>
            <if test="delFlag != null">del_flag = #{delFlag},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteStsBonusRulesById" parameterType="Long">
        delete from srs_bonus_rules where id = #{id}
    </delete>

    <delete id="deleteStsBonusRulesByIds" parameterType="String">
        delete from srs_bonus_rules where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
</mapper>